export interface StorageOptions {
  // 名称，必须全局唯一
  name: string
  // 存储/取值时是否加密处理
  encrypt?: boolean
  // 存储对象
  storage?: any
  // 命名空间
  namespace?: string | Function
}

export interface Storage<T> {
  name: string
  encrypt?: boolean
  storage: any
  namespace?: string | Function
  set(data: T): void
  get(): T
  setJSON(data: T): void
  getJSON(): T
  getNamespace(): string
  setByNamespace(data: T): void
  getByNamespace(): T
  remove(): void
}

export interface LocalItem<T> extends Storage<T> {
  storage: WindowLocalStorage
  new(options: StorageOptions): this
}

export interface SessionItem<T> extends Storage<T> {
  storage: WindowSessionStorage
  new(options: StorageOptions): this
}

export class storage {
  static LocalItem: LocalItem<any>
  static SessionItem: SessionItem<any>
}