
type GetBaseApiUrl = () => (string | { url: string }) | string

export interface WearOptions {
  config: object
  getBaseApiUrl: GetBaseApiUrl
  ajaxRequest: (config: object) => Promise<any>
  handleRequest: (config: object) => object
  handleResponse: (response: any, config: object) => any
  handleError: (response: any, config: object) => any
}

/**
 * 为wepy封装的ajax request
 *
 * @export
 * @interface Wear
 */
export interface Wear {
  static options: WearOptions
  static extendOptions: (options: WearOptions) => Wear
  static request: (config: object) => Promise<any>
  static get: (url: string, data: object) => Promise<any>
  static post: (url: string, data: object) => Promise<any>
  static put: (url: string, data: object) => Promise<any>
  static del: (url: string, data: object) => Promise<any>

  private config: object
  private baseApiUrl: string
  private getBaseApiUrl: GetBaseApiUrl
  private ajaxRequest: (config: object) => Promise<any>
  private handleRequest: (config: object) => object
  private handleResponse: (response: any, config: object) => any
  private handleError: (response: any, config: object) => any
  private resolveBaseApiUrl: () => Promise<string>

  public extendOptions: (options: object) => this
  public setConfig: (config: object) => this
  public request: (config: object) => Promise<any>
  public get: (url: string, data: object) => Promise<any>
  public post: (url: string, data: object) => Promise<any>
  public put: (url: string, data: object) => Promise<any>
  public del: (url: string, data: object) => Promise<any>
}